---
layout: docs
toc_group: reference-manual
link_title: Reference Manuals
permalink: /reference-manual/
redirect_from: /docs/reference-manual/
---

# GraalVM Reference Manuals

Here you will find the in-depth documentation for technologies offered by GraalVM.
These manuals are aimed at software engineers and developers who already work with GraalVM, or are considering it as an environment for their workloads.

## Technologies

[Native Image](native-image/README.md) - learn in detail about Native Image: GraalVM's innovative technology that can ahead-of-time compile Java code to a self-contained native executable.

[Java on Truffle](java-on-truffle/README.md) - learn how to run Java via a Java bytecode interpreter, implemented with the [Truffle framework](../../truffle/docs/README.md).

[Polyglot Programming](polyglot-programming.md) - learn how to write polyglot applications and allow languages to directly interoperate with each other in the same memory space.

[Embedding Languages](embedding/embed-languages.md) - learn how to embed polyglot applications in Java host applications or native images.

## Specific Languages

If you are mostly interested in the GraalVM support for a specific language, here you can find the most extensive documentation:

* [JavaScript and Node.js](js/README.md)
* [LLVM Languages](llvm/README.md)
* [Python](python/README.md)
* [R](r/README.md)
* [Ruby](ruby/README.md)
* [WebAssembly](wasm/README.md)