/*
 * Copyright (c) 2017, 2022, Oracle and/or its affiliates.
 *
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification, are
 * permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice, this list of
 * conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright notice, this list of
 * conditions and the following disclaimer in the documentation and/or other materials provided
 * with the distribution.
 *
 * 3. Neither the name of the copyright holder nor the names of its contributors may be used to
 * endorse or promote products derived from this software without specific prior written
 * permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
 * GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 */
#include <graalvm/llvm/polyglot.h>
#include <truffle.h>
#include <stdint.h>

int main() {
    void *p = polyglot_import("object");
    void *p1 = truffle_handle_for_managed(p);
    void *p2 = truffle_deref_handle_for_managed(p);
    int64_t l_p1 = (int64_t) p1;
    int64_t l_p2 = (int64_t) p2;
    void *n = calloc(sizeof(char), 2);

    if (!truffle_is_handle_to_managed(p1)) {
        return 1;
    }
    if (!truffle_is_handle_to_managed((void *) l_p1)) {
        return 2;
    }
    if (!truffle_is_handle_to_managed(p2)) {
        return 3;
    }
    if (!truffle_is_handle_to_managed((void *) l_p2)) {
        return 4;
    }
    if (truffle_is_handle_to_managed(p)) {
        return 5;
    }
    if (truffle_is_handle_to_managed(n)) {
        return 6;
    }
    free(n);

    return 0;
}
